function varargout = AF_calc(varargin)
% AF_CALC MATLAB code for AF_calc.fig
%      AF_CALC, by itself, creates a new AF_CALC or raises the existing
%      singleton*.
%
%      H = AF_CALC returns the handle to a new AF_CALC or the handle to
%      the existing singleton*.
%
%      AF_CALC('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in AF_CALC.M with the given input arguments.
%
%      AF_CALC('Property','Value',...) creates a new AF_CALC or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before AF_calc_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to AF_calc_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help AF_calc

% Last Modified by GUIDE v2.5 06-Aug-2014 18:16:18

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @AF_calc_OpeningFcn, ...
                   'gui_OutputFcn',  @AF_calc_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before AF_calc is made visible.
function AF_calc_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to AF_calc (see VARARGIN)

% Choose default command line output for AF_calc
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes AF_calc wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = AF_calc_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;




% --- Executes during object creation, after setting all properties.
function edit_fd_start_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_fd_start (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function edit_fd_stop_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_fd_stop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





% --- Executes during object creation, after setting all properties.
function edit_fd_step_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_fd_step (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in button_calculateAF.
function button_calculateAF_Callback(hObject, eventdata, handles)
global t f s2 Hf tau Af f0 alfa 
% hObject    handle to button_calculateAF (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
u=find(t>tau-10/Af & t<tau+10/Af);

%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%fd SWEEP%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%
fd=str2num(get(handles.edit_fd_start,'String'))...
    :str2num(get(handles.edit_fd_step,'String'))...
    :str2num(get(handles.edit_fd_stop,'String'));
ampl=zeros(length(fd),length(u));

for i=1:length(fd)
    %%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%TARGET%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%
    v=3e8*fd(i)/(2*f0);
    %The doppler shift of the target is simulated.
    s3=target(1,0,v,f0,s2,f,t);
    S3=fft(s3);

    %%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%RECEPTOR%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%
    %%%%Matched filter%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%
    %We filter the recieved signal with the matched filter.
    R=S3.*Hf;
    r=ifft(R);
    %%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%Detection%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%  
    r_detected=detect(f,f0,Af,alfa,t,r,'nc2');  
    ampl(i,:)=r_detected(u);
end 
 

%We plot the result.
screen_size = get(0, 'ScreenSize');
figure(1)
set(gcf(), 'Position', [0 0 screen_size(3) screen_size(4) ] )
contour((t(u)-tau),fd/1e3,ampl/max(max(ampl)),30)
grid on, title('Ambiguity Function','FontSize',10), hold on;
xlabel('Time (t-t_o)','FontSize',10),ylabel('Doppler Shift [Khz]','FontSize',10);
u_max1=find(ampl(end,:)==max(ampl(end,:)));
u_max2=find(ampl(1,:)==max(ampl(1,:)));
slope=(fd(end)-fd(1))/(t(u_max1)-t(u_max2));
txt=text(-9/Af,max(fd)/1e3-5,['Af=' num2str(Af/1e3),'(Khz)',char(10),'Slope=',...
 num2str(slope/1e3),'e3',char(10),'Af*T=',num2str(Af*tau)],'FontSize',10);
set(txt,'HorizontalAlignment','left','VerticalAlignment','bottom');
set(txt,'EdgeColor','black');
hold off;



