%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%fm_law.m%%%
%%%%%%%%%%%%%%%%%%%%%%%
%%%%Description: This function generates a overall linear chirp pulse. 
%%%%INPUTS:
%%%%f0 is the central frequency of the pulse.
%%%%dt ratio (duty cicle)/(signal period).
%%%%Af is the maximun frequency excursion.
%%%%Np number of pulse replications.
%%%%prf is 1/(signal period).
%%%%fs sample frequency.
%%%%OUTPUTS:
%%%%s2 is the chirp pulse.
%%%%t is the time axis.
%%%%f is the frequency axis.
function [s2]=fm_law(f0,dt,fi,Np,prf,fs,tp)
%Constants and parameters
T=1/prf;
Nm=ceil(T*fs);
%Simple pulse
wi=2*pi*fi;
%figure(),
%plot(tp,wi/(2*pi),'k'),title ('Instantaneous frequency');
%xlabel('Time'), ylabel('fi(t)'), grid on;
s1=sin(wi.*tp); 
s1=[s1 zeros(1,floor((1-dt)*Nm))] ; 
%Pulse replications and axis generation
s2=repmat(s1,1,Np);

end
