
warning('off','all');
warning;
global f0 Af alfa fs prf T dt tau Np v Rt srr fm_law_bool fi ...
    multi_target_bool mismatched_bool wn_bool clutter_bool p_n tp ...
    f t s2 S2 S3 s3 R r Hf gates r_detected R_DETECTED r_mis Hmis ...
    mismatch_type par1 par2
%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%TRANSMITTER%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%
if fm_law_bool
    %We generate the FM pulse. 
    Nm=ceil(T*fs);
    N=Nm*Np;
    t=linspace(0,Np*T,N);
    f=linspace(-0.5*fs,0.5*fs,N);
    tp=linspace(0,tau,ceil(Nm*dt));
    [s2]=fm_law(f0,dt,fi,Np,prf,fs,tp);

else
    %We generate the pulse chirp by chirp_linear function. 
    [s2,t,f]=chirp_lineal(f0,dt,Af,Np,prf,fs);
end
S2=fft(s2);




%%%%%%%%%%%%%%%%%%%%%%%
%%%%%TARGETs & CH%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%
%We simulate the target effect by executing the target function.

if  multi_target_bool
    s3=zeros(1,length(t));
    for i=1:length(v)
        s3=s3+target(srr(i),Rt(i),v(i),f0,s2,f,t);
    end
else 
    s3=target(srr,Rt,v,f0,s2,f,t);
end

if wn_bool
    s3=s3+wgn(1,length(s3),p_n);
end


if clutter_bool
    B=fir1(25,(1e3)*2/fs);
    c=filter(B,1,wgn(1,length(s3),-40*rand));
    s3=s3+c;
end


S3=fft(s3);    
s3=real(s3);

%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%RECEPTOR%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%
%%%%Matched filter%%%%%
%%%%%%%%%%%%%%%%%%%%%%%

%We calculate the matched filter reponse in frequency domain, 
%it will be matched to the transmitted signal.
t0=tau;
Hf=conj(S2).*exp(-1i*2*pi*f*t0);


%Then, we filter the received signal.
R=S3.*Hf;
r=ifft(R);
r=real(r);


%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%Detection%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%

%We detect the compressed signal. 
flag='nc2';
if (mismatched_bool)
    %%%%%%%%%%%%%%%%%%%%%%%
    %%%MisMatched filter%%%
    %%%%%%%%%%%%%%%%%%%%%%%
    if mismatch_type == 2
        Hmis=taylorf(f,f0,Af,par2,par1);
    else
        Hmis=taylor_truncated(f,f0,Af,par2,par1);        
    end
    R_mis=fftshift(Hmis).*R;
    r_mis=real(ifft(R_mis));
    r_detected=detect(f,f0,Af,alfa,t,r_mis,flag);
else
    r_detected=detect(f,f0,Af,alfa,t,r,flag);
end
R_DETECTED=fft(r_detected);





%Next, we implement the range gates.
width=1/(Af);
gates=ran_gate(t,width,T,tau);



